package org.projectopen.timesheet;

/*
 * Copyright (C) 2010 ]project-open[ 
 *
 * This program is free software. You can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2 of the License, or (at your option)
 * any later version. This program is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * @author Frank Bergmann (frank.bergmann@project-open.com)
 * 
 */

import java.util.Hashtable;
import java.util.Enumeration;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

@SuppressWarnings("unchecked")

/*
 * A ProjopObject mainly consists of a lists of variables
 */
public class ProjopObject {
	
	private String objectType;
	private int objectId;

	private Hashtable vars;

	public static int getIntValue(Element ele, String tagName) {
		//in production application you would catch the exception
		return Integer.parseInt(getTextValue(ele,tagName));
	}

	public static ProjopObject objectFromXML(Element el) {
		return null;
	}
	
	public String toXMLString() {
		
		StringBuffer buf = new StringBuffer();

		Enumeration e = vars.keys();
    	while(e.hasMoreElements()){
    		Object var = e.nextElement();
    		buf.append("<"+var.toString()+">"+vars.get(var)+"</"+var.toString()+">\n");
    	}		
		String result = "<" + objectType + ">\n" + buf + "\n</" + objectType + ">\n";
		return result;
	}
	
	public static String getTextValue(Element ele, String tagName) {
		String textVal = null;
		NodeList nl = ele.getElementsByTagName(tagName);
		if(nl != null && nl.getLength() > 0) {
			Element el = (Element)nl.item(0);
			textVal = el.getFirstChild().getNodeValue();
		}
		return textVal;
	}

	/*
	 * Small helper for working with XML in string representation
	 */
	public static String htmlEncode(String s) {
		String result = s;
		result = result.replaceAll("&", "&amp;");
		result = result.replaceAll("<", "&lt;");
		result = result.replaceAll(">", "&gt;");
		result = result.replaceAll("\"", "&quot;");
				
		return result;		
	}
	
	
	public String get(String varName) { return (String)vars.get(varName); }
	public void set(String varName, String value) { vars.put(varName, value); }
	public String getObjectType() {	return objectType; }
	public int getObjectId() { return objectId; }
	public void setObjectId(int objectId) {	this.objectId = objectId; }
	public void setObjectType(String objectType) { this.objectType = objectType; }
	public Hashtable getVars() { return vars; }

	public ProjopObject(String objectType) {
		this.objectType = objectType;
		vars  = new Hashtable(20);
	}
	
	public String toString() {	
		return objectType + ":" + objectId + ":" + vars;
	}
	
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {
    	ProjopObject o1 = new ProjopObject("im_project");
    	
    	System.out.println("Retriving all keys from the Hashtable");
    	Enumeration e = o1.getVars().keys();
    	while( e.hasMoreElements() ){
    		System.out.println( e.nextElement() );
    	}
    }
}
